
#include <stdio.h>
#include <memory.h>
#include <time.h>
#include <windows.h>
#include "Console.h"

char Screen[HEIGHT][WIDTH];	//	ȭ   迭

//	÷̾   
#define PLAYER_SIZE          5	//	÷̾  ũ
char PlayerUnit[PLAYER_SIZE + 1] = "-=^=-";

struct PlayerInfo 
{
	int x, y;		//	 迭 ÷̾ ġ, x  y  ǹ.
					//	 ġ ߽  ̴.

	int LiveFlag;	//	1 ϸ , 0̸ ׾ ǹ.
};

struct PlayerInfo         Player;

/*	÷̾   ʱȭ ϴ Լ	*/
void InitialObject(void);

/*	
	Ű ԷµǸ ÷̾ ǥ Ʈϴ Լ, 
	ǥ Ʈϰ  ȭ   ʰ ó ϴµ 
	̴  迭 ũ⸦ ̿ؼ óѴ.	
*/
void PlayerAction(void);

/*	÷̾  ȭ 迭 ϴ Լ	*/
void DrawPlayer(void);

/*	 迭 Ǿִ  Ʈ ܼ ȭ鿡 ϴ Լ	*/
void Draw(void);

int main(void)
{
	Initial();				//	ܼ ȭ â ʱȭ
	InitialObject();		//	Ʈ ʱȭ

	while (1) 
	{
		PlayerAction();		//	÷̾ ̵
		
		Draw();				//	Ʈ ܼȭ鿡 

		Sleep(100);
	}

	return 0;
}

/*	÷̾   ʱȭ ϴ Լ	*/
void InitialObject(void)
{
	//	÷̾ ʱȭ 
	Player.x = 39;
	Player.y = 19;
	Player.LiveFlag = 1;

	//	߿ ʹ  ٸ Ʈ鿡  ʱȭ 뵵 
}

/*	
	Ű ԷµǸ ÷̾ ǥ Ʈϴ Լ, 
	ǥ Ʈϰ  ȭ   ʰ ó ϴµ 
	̴  迭 ũ⸦ ̿ؼ óѴ.	
*/
void PlayerAction(void)
{
	//	GetAsyncKeyState  short   ڸ üũϱ 0x8000  Ʈ
	//	0x8000  2 Ÿ 1000 0000 0000 0000

	//	 y() Ʈϰ  迭   Ȯ Ѵ.
	if ( GetAsyncKeyState(VK_UP) & 0x8000 ) 
	{
		Player.y--;	//	 ̵Ϸ   ۾ Ѵ.
		if ( Player.y < 0 )							
			Player.y = 0;
	}

	//	Ʒ y() Ʈϰ  迭   Ȯ Ѵ.
	if ( GetAsyncKeyState(VK_DOWN) & 0x8000 ) 
	{
		Player.y++;	//	Ʒ ̵Ϸ   Ŀ Ѵ.
		if (Player.y >= HEIGHT - 1)					
			Player.y = HEIGHT - 2;
	}

	//	 x() Ʈϰ  迭   Ȯ Ѵ.
	if ( GetAsyncKeyState(VK_LEFT) & 0x8000 ) 
	{
		Player.x -= 2;	//	 ̵Ϸ   ۾ Ѵ.
		if (Player.x < PLAYER_SIZE / 2)		//	÷̾    迭  üũ
			Player.x = PLAYER_SIZE / 2;
	}

	//	 x() Ʈϰ  迭   Ȯ Ѵ.
	//	 迭     ڸ NULLڰ Ե ڸ̹Ƿ,  ġ ŰἭ óؾ Ѵ.
	//	  x ( WIDTH - 2 ) Ѿ  ó ʿ
	if ( GetAsyncKeyState(VK_RIGHT) & 0x8000 ) 
	{
		Player.x += 2;	//	 ̵Ϸ   Ŀ Ѵ.
		if (Player.x >= WIDTH - 2 - PLAYER_SIZE / 2)//	÷̾    迭  üũ
			Player.x = WIDTH - 2 - PLAYER_SIZE / 2;
	}
}

/*	÷̾  ȭ 迭 ϴ Լ	*/
void DrawPlayer(void)
{
	int i;
	int x = Player.x - PLAYER_SIZE / 2;	//	÷̾ ʳ x()
	int y = Player.y;					//	÷̾ 
	
	//	÷̾ ġ()  迭 Ѿ  迭  ν
	//	ȭ鿡   ʰڴٴ ǹ.
	if ( y < 0 || y >= HEIGHT ) 
		return;
	
	//	 迭 ÷̾   ¸ . 
	for ( i = 0; i < PLAYER_SIZE; i++ ) 
	{
		if ( x >= 0 && x < WIDTH ) 
			Screen[y][x] = PlayerUnit[i];
		
		x++;	//	÷̾   ϱ    ̵
	}
}

/*	 迭 Ǿִ  Ʈ ܼ ȭ鿡 ϴ Լ	*/
void Draw(void)
{
	int i;
	
	//	 迭 ʱȭ
	for ( i = 0; i < HEIGHT; i++ ) 
	{
		memset(Screen[i], ' ', WIDTH);	//	鹮
		Screen[i][WIDTH - 1] = 0;		//	 迭    ڸ NULL 
	}
	
	//	÷̾  迭 
	DrawPlayer();
	
	//	߿, ʹ  ٸ Ʈ鿡  뵵  迭 ϰ .

	//	Ʈ ܼ ȭ â ϴ ,  迭    ϸ ȴ.
	//	 迭 2   ȭ ġ xǥ 0 ϰ yǥ 2̴.
	//	, 0  ȭ ġ (0,0), 1  ȭ ġ (0,1) ϸ ȴ.
	for ( i = 0; i < HEIGHT; i++ ) 
	{
		MoveCursor(0, i);		//	 迭  ȭ ǥ y̴.
		printf( Screen[i] );	
	}
}